// importation du package qui contient la classe Random
import java.util.Random;

// document sur l'API java : http://docs.oracle.com/javase/6/docs/api/

// déclaration d'un objet de type Random
Random generator ;

/******************************
 * génération d'un nombre pseudo-aléatoire entier entre a et b
 *
 * entrée : a, b : borne de l'intervalle
 *
 * sortie : nombre pseudo-aléatoire uniforme de [a,b]
 *******************************************/
 int aleaInt(int a, int b) {
   return a + generator.nextInt(b - a + 1);
 }
 
/******************************
 * génération d'un nombre pseudo-aléatoire approché entre a et b
 *
 * entrée : a, b : borne de l'intervalle
 *
 * sortie : nombre pseudo-aléatoire uniforme de [a,b[
 *******************************************/
 float aleaFloat(float a, float b) {
   return a + generator.nextFloat() * (b - a);
 }
 

 /**************************************************/
 void setup() {
   // initialisation du l'objet
  generator = new Random();
  
  for(int i = 0; i < 40; i++)
    print(aleaInt(10, 20) + " ");
 
  println();
  for(int i = 0; i < 40; i++)
    print(aleaFloat(10, 20) + " ");
}
