/******************************
 * classe qui simule le comportement d'un cercle insaisissable...
 *******************************************/
class Cercle {
// --------- les champs de la classe ------------

  // rayon du cercle
  int r;
  
  // deplacement maximal
  float delta;
  
  // position horizontale et verticale
  int x, y;
  
  // couleur du cercle
  color couleur;
  
// ---------- les constructeurs ------------
  
  /****************************************
   * constructeur qui initialise tous les champs
   *
   * entrée : aucune
   ****************************************/
  Cercle() {
    r     = 10;
    delta = 5;
    y     = 0;
    x     = 0;
    couleur = color(255, 0, 0);
  }
  
  /****************************************
   * constructeur qui initialise tous les champs
   *
   * entrée : xInit, yInit : valeur intiales
   ****************************************/
  Cercle(int rInit, float deltaInit, int xInit, int yInit) {
    r     = rInit;
    delta = deltaInit;
    x     = xInit;
    y     = yInit;
    couleur = color(int(random(256)), int(random(256)), int(random(256)));
  }
  
// ---------- les méthodes ------------

  /****************************************
   * permet le dessin sur le canevas de la balle
   *
   * entrée : 
   *     aucune
   *
   * sortie :
   *     aucune seulement changement du canevas
   ****************************************/
  void dessineToi() {
    fill(couleur);
    ellipse(x, y, 2 * r, 2 * r);
  }
  
  /****************************************
   * teste si la souris est dans le cercle
   *
   * entrée : 
   *     aucune (en fait l'état de la souris)
   *
   * sortie :
   *     true/false si clique sur le cercle
   ****************************************/
  boolean dedans() { 
    return (x - mouseX) * (x - mouseX) + (y - mouseY) * (y - mouseY) < r * r; 
  }
  
  /****************************************
   * modifie aléatoirement la position du cercle s
   *
   * entrée : 
   *     aucune
   *
   * sortie :
   *     aucune seulement changement de l'état interne
   ****************************************/
  void move() {
      x = x + int(random(-delta, delta));
      y = y + int(random(-delta, delta));

      if (x + r > width) 
        x = width - r;
      else 
        if (x - r < 0)
          x = r;
    
      if (y + r > height) 
        y = height - r;
      else
        if (y - r < 0)
          y = r;
  }
  
  /****************************************
   * donne l'état du cercle
   *
   * entrée : 
   *     aucune
   *
   * sortie :
   *     chaine de caractères donnant l'état
   ****************************************/
  public String toString() {
    return "Balle [r=" + r + ", delta=" + delta + ", x=" + x + ", y=" + y + "]" ;
  }
  
}
 
/**************************************************/
Cercle [] cercles;

void setup() {
  size(400, 400);
  fill(255, 0, 0);
  noStroke();
  
  cercles = new Cercle[15];
  
  int r = 20;
  for(int i = 0; i < cercles.length; i++) {
    cercles[i] = new Cercle(r, 100, int(random(r, width - r)), int(random(r, height - r)));
  }
  
}

void draw() {
  background(0, 0, 0);
  for(int i = 0; i < cercles.length; i++) {
    cercles[i].dessineToi();
  }
//  c.move();
}

void mousePressed() {
  for(int i = 0; i < cercles.length; i++) {
    if (cercles[i].dedans())
      cercles[i].move();
  }
}
